diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index c648dd819..4de644106 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -23,6 +23,7 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import org.jetbrains.annotations.NotNull;
@@ -51,7 +52,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ChatLine;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.season.Season;
@@ -146,7 +146,7 @@ public class HudIngame extends Gui {
             boolean compass = false;
             boolean rotaryCalendar = false;
 
-            if (this.mc.thePlayer.getGamemode() == Gamemode.creative) {
+            if (this.mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
                 clock = true;
                 compass = true;
                 rotaryCalendar = true;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 9b49a334d..4b0dd4956 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -99,7 +99,7 @@ public class HudIngameDoom
         int height = this.mc.resolution.getScaledHeightScreenCoords();
 
         Face face = Face.NEUTRAL;
-        if (this.mc.thePlayer.getGamemode().isPlayerInvulnerable()) {
+        if (this.mc.thePlayer.getGamemode().hasInvulnerablePlayer()) {
             face = Face.GOD;
         } else if (this.mc.thePlayer.getHealth() == 0) {
             face = Face.DEAD;
@@ -168,7 +168,7 @@ public class HudIngameDoom
         int height = this.mc.resolution.getScaledHeightScreenCoords();
 
         int i = 1;
-        int activeSlot = this.mc.thePlayer.inventory.getCurrentItemIndex() % 9;
+        int activeSlot = this.mc.thePlayer.inventory.getCurrentSlot() % 9;
         for (int y = 0; y < 2; y++) {
             for (int x = 0; x < 5; x++) {
                 if (i >= 10) continue;
@@ -226,8 +226,8 @@ public class HudIngameDoom
         int width = this.mc.resolution.getScaledWidthScreenCoords();
         int height = this.mc.resolution.getScaledHeightScreenCoords();
 
-        int currentItem = this.mc.thePlayer.inventory.getCurrentItemIndex();
-        int wrappedCurrentItem = this.mc.thePlayer.inventory.getCurrentItemIndex() % 9;
+        int currentItem = this.mc.thePlayer.inventory.getCurrentSlot();
+        int wrappedCurrentItem = this.mc.thePlayer.inventory.getCurrentSlot() % 9;
 
         int offset = 0;
         if (wrappedCurrentItem >= 5) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
index d1c35f580..99e610a4d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
@@ -15,7 +15,7 @@ public class HudComponentFireBar
 
     @Override
     public boolean isVisible() {
-        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.remainingFireTicks > 0;
+        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && mc.thePlayer.remainingFireTicks > 0;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index fced9f1d9..72a5641f4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -11,7 +11,7 @@ import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.phys.HitResult;
 
 import java.util.Random;
@@ -26,7 +26,7 @@ public class HudComponentHealthBar
 
     @Override
     public boolean isVisible() {
-        return mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.gameSettings.immersiveMode.drawHotbar();
+        return mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && mc.gameSettings.immersiveMode.drawHotbar();
     }
 
     @Override
@@ -45,7 +45,7 @@ public class HudComponentHealthBar
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
         this.random.setSeed(hud.updateCounter * 0x4c627L);
-        boolean isHardcore = mc.thePlayer.getGamemode() == Gamemode.hardcore;
+        boolean isHardcore = mc.thePlayer.getGamemode() == Gamemodes.HARDCORE;
 
         for (int i = 0; i < 10; i++) {
             int heartOffset = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 95f9bce85..1872d0e93 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -134,7 +134,7 @@ public class HudComponentHotbar
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
 
         // Render selector
-        hud.drawGuiIcon((x + 4) + (inv.getCurrentItemIndex() % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
+        hud.drawGuiIcon((x + 4) + (inv.getCurrentSlot() % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
 
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate(0, 0, 1f);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index 8e0adcd7f..aefc6f87c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -10,7 +10,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.biome.Biomes;
@@ -64,7 +64,7 @@ public class HudComponentInfoOverlay
         boolean compass = false;
         boolean rotaryCalendar = false;
 
-        if (mc.thePlayer.getGamemode() == Gamemode.creative) {
+        if (mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
             clock = true;
             compass = true;
             rotaryCalendar = true;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
index 88f4f4a44..3fc7f4bec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
@@ -23,7 +23,7 @@ public class HudComponentOxygenBar
 
     @Override
     public boolean isVisible() {
-        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.isUnderLiquid(Materials.WATER);
+        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && mc.thePlayer.isUnderLiquid(Materials.WATER);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 83778423c..44a7a8e58 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -50,6 +50,7 @@ import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
 import net.minecraft.core.player.inventory.container.ContainerSimple;
 import net.minecraft.core.sound.SoundTypes;
@@ -69,6 +70,7 @@ import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.BufferedReader;
@@ -78,10 +80,7 @@ import java.net.InetAddress;
 import java.net.Socket;
 import java.net.URL;
 import java.net.UnknownHostException;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Random;
+import java.util.*;
 
 public class PacketHandlerClient extends PacketHandler
 {
@@ -340,20 +339,18 @@ public class PacketHandlerClient extends PacketHandler
         final int itemId = packetAddPlayer.currentItem;
         if (itemId == 0)
         {
-            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentItemIndex()] = null;
+            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentSlot()] = null;
         }
         else
         {
-            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentItemIndex()] = new ItemStack(itemId, 1, 0);
+            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentSlot()] = new ItemStack(itemId, 1, 0);
         }
         playerRemote.absMoveTo(x, y, z, yRot, xRot);
         this.worldClientMP.addEntityToWorld(packetAddPlayer.entityId, playerRemote);
         playerRemote.nickname = StringUtils.substring(packetAddPlayer.nickname, 0, 32);
         playerRemote.chatColor = packetAddPlayer.chatColor;
-        if (packetAddPlayer.gamemode >= 0 && packetAddPlayer.gamemode < Gamemode.gamemodesList.length) {
-            playerRemote.setGamemode(Gamemode.gamemodesList[packetAddPlayer.gamemode]);
-        }
-
+        final @Nullable Gamemode gamemodeFromPacket = Registries.GAMEMODES.getItem(packetAddPlayer.gamemode);
+        playerRemote.setGamemode(Objects.requireNonNullElse(gamemodeFromPacket, Gamemodes.SURVIVAL));
         playerRemote.setHeldObject(packetAddPlayer.heldObjectTag == null ? null : ICarriable.createAndLoadCarriable(playerRemote, packetAddPlayer.heldObjectTag));
     }
 
@@ -1145,7 +1142,10 @@ public class PacketHandlerClient extends PacketHandler
     {
         Entity entity = getEntityByID(packet.entityId);
         if (entity instanceof Player){
-            ((Player) entity).setGamemode(Gamemode.gamemodesList[packet.gamemodeId]);
+            final @Nullable Gamemode gamemodeFromPacket = Registries.GAMEMODES.getItem(packet.gamemodeId);
+            if (gamemodeFromPacket != null) {
+                ((Player) entity).setGamemode(gamemodeFromPacket);
+            }
         }
     }
 
@@ -1168,7 +1168,7 @@ public class PacketHandlerClient extends PacketHandler
     
     @Override
     public void handleSetCarriedItem(@NotNull PacketSetCarriedItem packetSetCarriedItem) {
-        mc.thePlayer.inventory.setCurrentItemIndex(packetSetCarriedItem.id, true);
+        mc.thePlayer.inventory.setCurrentSlot(packetSetCarriedItem.id, true);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 2524d34c1..128849c9c 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -41,7 +41,7 @@ public abstract class PlayerController {
 	public void startDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit, boolean repeat) {
 		if (mc.thePlayer.getHeldObject() != null) return;
 		if (!mc.thePlayer.getGamemode().canInteract()) return;
-		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim()) {
+		if(!mc.thePlayer.getGamemode().hasBlockBreakingAnimation()) {
 			swingItem(true);
 			
 			ItemStack heldItem = mc.thePlayer.getCurrentEquippedItem();
@@ -70,7 +70,7 @@ public abstract class PlayerController {
 	
 	//Called 20 times per second when the mouse button is held and blocks are targeted
 	public void continueDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim() || !mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) {
+		if(!mc.thePlayer.getGamemode().hasBlockBreakingAnimation() || !mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) {
 			return;
 		}
 		
@@ -301,9 +301,9 @@ public abstract class PlayerController {
 		int prevStackSize = stack.stackSize;
 		ItemStack newItemStack = stack.useItemRightClick(world, player);
 		if(newItemStack != stack || newItemStack.stackSize != prevStackSize) {
-			player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = newItemStack;
+			player.inventory.mainInventory[player.inventory.getCurrentSlot()] = newItemStack;
 			if(newItemStack == null || newItemStack.stackSize <= 0) {
-				player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = null;
+				player.inventory.mainInventory[player.inventory.getCurrentSlot()] = null;
 			}
 			return true;
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 2aba8d3e4..039a95ac7 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -57,7 +57,7 @@ public class PlayerControllerMP extends PlayerController {
 	
 	@Override
 	protected void syncCurrentPlayItem() {
-		int i = mc.thePlayer.inventory.getCurrentItemIndex();
+		int i = mc.thePlayer.inventory.getCurrentSlot();
 		if (i != currentItem) {
 			currentItem = i;
 			netHandler.addToSendQueue(new PacketSetCarriedItem(currentItem));
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 10f31693a..764cf9ece 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -26,7 +26,7 @@ public class PlayerControllerSP extends PlayerController {
 		if (item != null) {
 			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
 		}
-		if (removed && mc.thePlayer.getGamemode().dropBlockOnBreak()) {
+		if (removed && mc.thePlayer.getGamemode().hasItemDrops()) {
 			Blocks.blocksList[id].harvestBlock(mc.currentWorld, mc.thePlayer, x, y, z, meta, tileEntity);
 		}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index a21273c1f..367f70d98 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -281,7 +281,7 @@ public class ItemRenderer {
         this.oHeight = this.height;
         PlayerLocal playerLocal = this.mc.thePlayer;
         ItemStack itemstack = playerLocal.inventory.getCurrentItem();
-        boolean flag = this.lastSlot == playerLocal.inventory.getCurrentItemIndex() && itemstack == this.itemToRender;
+        boolean flag = this.lastSlot == playerLocal.inventory.getCurrentSlot() && itemstack == this.itemToRender;
         if (this.itemToRender == null && itemstack == null) {
             flag = true;
         }
@@ -301,7 +301,7 @@ public class ItemRenderer {
         this.height += f2;
         if (this.height < 0.1F) {
             this.itemToRender = itemstack;
-            this.lastSlot = playerLocal.inventory.getCurrentItemIndex();
+            this.lastSlot = playerLocal.inventory.getCurrentSlot();
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 9c7478508..aa4f2e796 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
@@ -26,7 +27,7 @@ public final class Lighting {
     }
 
     public static void enableLight() {
-        enableLight(0.5f, 0.6f);
+        enableLight(0.5f, 0.5f);
     }
 
     public static void enableLight(float ambientBrightness, float lightBrightness) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index acfee9305..bbb159fe4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.render;
 
-import java.util.Arrays;
-
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -16,13 +14,13 @@ final public class LightingCache {
     private static final int CACHE_RANGE = 1;
     private static final int CACHE_SIZE = CACHE_RANGE * 2 + 1;
 
-    private final boolean[] brightnessCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private int brightnessCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
     private final float[] brightnessValue = new float[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
 
-    private final boolean[] opacityCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
-    private final boolean[] opacityValue = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private int opacityCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private int opacityValue = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
 
-    private final boolean[] lightmapCoordCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private int lightmapCoordCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
     private final int[] lightmapCoordValue = new int[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
 
     private final @NotNull TilePos offset = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
@@ -40,9 +38,9 @@ final public class LightingCache {
         if (!tilePos.equals(this.offset) || this.block != block || this.access != source) {
             this.block = block;
             this.access = source;
-            Arrays.fill(this.brightnessCached, false);
-            Arrays.fill(this.opacityCached, false);
-            Arrays.fill(this.lightmapCoordCached, false);
+            this.brightnessCached = 0;
+            this.opacityCached = 0;
+            this.lightmapCoordCached = 0;
             this.offset.set(tilePos);
         }
     }
@@ -66,9 +64,9 @@ final public class LightingCache {
     public float getBrightness(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
 
-        if (!this.brightnessCached[index]) {
+        if (!bitGet(this.brightnessCached, index)) {
             this.brightnessValue[index] = calcBrightness(this.offset.add(relX, relY, relZ, this.queryPos));
-            this.brightnessCached[index] = true;
+            this.brightnessCached = bitSet(this.brightnessCached, index);
         }
 
         return this.brightnessValue[index];
@@ -76,20 +74,36 @@ final public class LightingCache {
 
     public boolean getOpacity(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
-        if (!this.opacityCached[index]) {
-            this.opacityValue[index] = Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, this.queryPos))];
-            this.opacityCached[index] = true;
+        if (!bitGet(this.opacityCached, index)) {
+            this.opacityValue = bitSetState(this.opacityValue, index, Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, this.queryPos))]);
+            this.opacityCached = bitSet(this.opacityCached, index);
         }
-        return this.opacityValue[index];
+        return bitGet(this.opacityValue, index);
     }
 
     public int getLightmapCoord(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
-        if (!this.lightmapCoordCached[index]) {
+        if (!bitGet(this.lightmapCoordCached, index)) {
             int lightEmission = this.block.emission;
             this.lightmapCoordValue[index] = this.access.getLightmapCoord(this.offset.add(relX, relY, relZ, this.queryPos), lightEmission);
-            this.lightmapCoordCached[index] = true;
+            this.lightmapCoordCached = bitSet(this.lightmapCoordCached, index);
         }
         return this.lightmapCoordValue[index];
     }
+
+    private static boolean bitGet(int value, int index) {
+        return (value & (1 << index)) != 0;
+    }
+
+    private static int bitSet(int value, int index) {
+        return (value | (1 << index));
+    }
+
+    private static int bitSetState(int value, int index, boolean state) {
+        if (state) {
+            return (value | (1 << index));
+        } else {
+            return (value & ~(1 << index));
+        }
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 4ae3f4066..77983d73f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -2,13 +2,13 @@ package net.minecraft.client.render;
 
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLeaves;
 import net.minecraft.client.render.particle.Particle;
 import net.minecraft.client.render.particle.ParticleDispatcher;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -34,6 +34,7 @@ import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -43,7 +44,6 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.BoundingVolume;
@@ -229,7 +229,7 @@ public class RenderGlobal
     public void allChanged() {
         ScreenOptions.queueReload = false;
         updateStars();
-        BlockModelLeaves.setGraphicsLevel(this.mc.gameSettings.fancyGraphics.value == 1);
+        BlockModelGenericLeaves.setGraphicsLevel(this.mc.gameSettings.fancyGraphics.value == 1);
         this.renderDistance = this.mc.gameSettings.renderDistance.value;
         if (this.world == null) return;
 
@@ -1491,7 +1491,7 @@ public class RenderGlobal
         }
 
         float entityRadius = 10.0f;
-        if (this.mc.thePlayer.getGamemode() == Gamemode.creative) {
+        if (this.mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
             entityRadius = 100.0f;
         }
         List<Entity> entitiesNearby = this.world.getEntitiesWithinAABBExcludingEntity(null, MathHelper.aabbGrow(this.mc.thePlayer.bb, entityRadius, entityRadius, entityRadius, new AABBd()));
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index ff7fa1795..130c9ce4e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -643,19 +643,19 @@ public class WorldRenderer {
 
         Debug.change("terrain");
         GLRenderer.pushFrame();
+        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
         GL41.glActiveTexture(GL41.GL_TEXTURE2);
         TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
 //        GL41.glActiveTexture(GL41.GL_TEXTURE3);
 //        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
         GL41.glActiveTexture(GL41.GL_TEXTURE0);
-
+        Lighting.enableLight();
         GLRenderer.setShader(Shaders.TERRAIN);
         GLRenderer.globalSetUniforms(Shaders.TERRAIN);
         this.lightmapHelper.enableLightmapRendering();
         this.mc.terrainRenderer.renderSolidTerrain(partialTicks);
         GLRenderer.popFrame();
 
-        Lighting.enableLight();
         Debug.change("entities");
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         renderGlobal.renderEntities(this.mc.activeCamera, partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 240654c51..7ce4d673a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -22,7 +22,7 @@ public abstract class BlockModel<T extends BlockLogic> {
     }
     public abstract boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
     public abstract boolean renderNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
-    public abstract boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex);
+    public abstract boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate overrideTexture);
     public abstract void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord);
 
     public abstract boolean shouldItemRender3d();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index bf2d2ab94..16b5112a7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -5,7 +5,6 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
@@ -80,15 +79,6 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
         double yd = tilePos.y();
         double zd = tilePos.z();
 
-        // Shift grass position with deterministic position based random
-        if (this.block == Blocks.TALLGRASS || this.block == Blocks.TALLGRASS_FERN || this.block == Blocks.SPINIFEX) {
-            long dRandom = (tilePos.x() * 0x2fc20fL) ^ (long) tilePos.z() * 0x6ebfff5L ^ (long) tilePos.y();
-            dRandom = dRandom * dRandom * 0x285b825L + dRandom * 11L;
-            xd += ((double) ((float) (dRandom >> 16 & 15L) / 15F) - 0.5D) * 0.5D;
-            yd += ((double) ((float) (dRandom >> 20 & 15L) / 15F) - 1.0D) * 0.2D;
-            zd += ((double) ((float) (dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
-        }
-
         int metadata = worldSource.getBlockData(tilePos);
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
         if (renderBlocks.overrideBlockTexture != null) {
